/*
 * Copyright 2016-present Open Networking Laboratory
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.onosproject.nemo.model.common;

import com.google.common.testing.EqualsTester;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * Unit tests for {@link ObjectId}.
 */
public class ObjectIdTest {

    private static final String ID =
            "14ce424a-3e50-4a2a-ad5c-b29845158c8b";
    private static final String OTHERID =
            "a4ce424a-3e50-4a2a-ad5c-b29845158c8b";

    private ObjectId id;
    private ObjectId copy;
    private ObjectId diff;

    @Test
    public void fromString() {
        id = new ObjectId(ID);
        assertEquals("name not set", ID, id.getValue());
    }

    @Test
    public void copyConstructor() {
        id = new ObjectId(ID);
        copy = new ObjectId(id);
        new EqualsTester()
                .addEqualityGroup(id, copy)
                .testEquals();
    }

    @Test
    public void equality() {
        id = new ObjectId(ID);
        copy = new ObjectId(ID);
        diff = new ObjectId(OTHERID);
        new EqualsTester()
                .addEqualityGroup(id, copy)
                .addEqualityGroup(diff)
                .testEquals();
    }
}