package org.onosproject.nemo.model.object.node.instance;
import static org.junit.Assert.assertEquals;

import org.junit.Test;
import org.onosproject.nemo.model.common.NodeId;

import com.google.common.testing.EqualsTester;

/**
 * Unit tests for {@link SubNodeKey}.
 */
public class SubNodeKeyTest {

    private static final String NODEID = "14ce424a-3e50-4a2a-ad5c-b29845158c8b";
    private static final String OTHER = "a4ce424a-3e50-4a2a-ad5c-b29845158c8b";
    private static final String NODEID_ERROR_MSG = "node id not set";

    private SubNodeKey key;
    private SubNodeKey copy;
    private SubNodeKey diff;

    @Test
    public void fromNodeId() {
        key = new SubNodeKey(new NodeId(NODEID));
        assertEquals(NODEID_ERROR_MSG, NODEID, key.getNodeId().getValue());
    }

    @Test
    public void copyConstructor() {
        key = new SubNodeKey(new NodeId(NODEID));
        copy = new SubNodeKey(key);
        new EqualsTester()
                .addEqualityGroup(key, copy)
                .testEquals();
    }

    @Test
    public void equality() {
        key = new SubNodeKey(new NodeId(NODEID));
        copy = new SubNodeKey(new NodeId(NODEID));
        diff = new SubNodeKey(new NodeId(OTHER));
        new EqualsTester()
                .addEqualityGroup(key, copy)
                .addEqualityGroup(diff)
                .testEquals();
    }
}